'use strict';

angular.module('adf.widget.electre.lavoisier')
.value('renderingIFrameList', {
    defaultRendering : 'pdf',
    renderings : [
        'chart',
        'gz',
        'html',
        'pdf',
        'xlsx.xml',
        'zip'
    ]
}).controller('lavoisierIFrameEditCtrl',
    [
        '$scope', 'config', '$controller', 'domService', 'renderingFactory', 'renderingIFrameList',
        function ($scope, config, $controller, domService, renderingFactory, renderingIFrameList) {
            $controller('lavoisierBaseEditCtrl',
                {
                    $scope : $scope,
                    config : config
                }
            );

            var height = {
                div_group   : domService.createElement("div").setAttribute('class', "form-group").getDom(),
                label       : domService.createElement("label").setAttribute('for', "table-edit-height").getDom(),
                input_group : {
                    div        : domService.createElement("div").setAttribute('class', "form-group").getDom(),
                    // Input de modification de la hauteur de l'iframe.
                    input      : domService.createElement("input")
                                        .setAttribute('id', "table-edit-height")
                                        .setAttribute('class', "form-control")
                                        .setAttribute('type', 'number')
                                        .setAttribute('style', 'width:85%;float:left;')
                                        .setAttribute('ng-model', "config.height")
                                        .getDom(),
                    // Simulation d'un bouton de réinitialisation de la hauteur de l'iframe.
                    clear_span : domService.createElement('span')
                                        .setAttribute('class', 'btn btn-default')
                                        .setAttribute('style', 'width:15%;float:right;')
                                        .setAttribute('ng-click', 'config.height=undefined;')
                                        .getDom(),
                    clear_div  : domService.createElement('div').setAttribute('style', 'clear:both;').getDom()
                }
            };
            height.label.innerHTML = "Height";
            height.input_group.clear_span.innerHTML = "Clear";

            // Ajout du input, du span et du dernier div au div de input_group.
            height.input_group.div.appendChild(height.input_group.input);
            height.input_group.div.appendChild(height.input_group.clear_span);
            height.input_group.div.appendChild(height.input_group.clear_div);
            // Ajout du label et du input_group au div global.
            height.div_group.appendChild(height.label); height.div_group.appendChild(height.input_group.div);

            renderingFactory.createRenderingDomFromArray(renderingIFrameList, angular.element(document.getElementById('edit_form_div_lavoisier')), config);
            angular.element(document.getElementById('edit_form_div_lavoisier')).append(height.div_group);
        }
    ]
);