'use strict';

angular.module('adf.widget.electre.lavoisier')
    .directive(
        'selectView',
        [
            
            "lavoisierHttpRequestService", "parserService", "LAVOISIER_TEMPLATES_PATH",
            function (lavoisierHttpRequestService, parserService, LAVOISIER_TEMPLATES_PATH) {
// Url liste des vues.
// Par nom :  "http://localhost:8080/lavoisier/configuration/cfg:config/cfg:view[cfg:info/cfg:category!='Hidden'%20and%20cfg:info/cfg:category!='Configuration'%20and%20cfg:info/cfg:category!='Environment'%20and%20cfg:info/cfg:category!='Monitoring']/@name?accept=xml";
// 
// Par nom et par category : 
// "http://localhost:8080/lavoisier/configuration
// /cfg:config/cfg:view[cfg:info/cfg:category!='Hidden'%20and%20cfg:info/cfg:category!='Configuration'%20and%20cfg:info/cfg:category!='Environment'%20and%20cfg:info/cfg:category!='Monitoring']/@name|
// /cfg:config/cfg:view[cfg:info/cfg:category!='Hidden'%20and%20cfg:info/cfg:category!='Configuration'%20and%20cfg:info/cfg:category!='Environment'%20and%20cfg:info/cfg:category!='Monitoring']/cfg:info/cfg:category[text()]?accept=xml"
                var templateUrl_;
                var noCategory = "noCategory";
                /**
                 * This is called if the update function has failed.
                 * @param {type} element
                 * @param {type} scope
                 * @param {Error} e 
                 */
                function failToLoadViews (element, scope, e) {
                    scope.config.view = undefined;
                    scope.control.viewMustBeInitialized = false;
                    scope.config.viewOk = false;
                    
                    throw e || "Request error in selectView directive!";
                }
                /**
                 * Mets à jours la liste des vues en utilisant l'url de base de lavoisier donnée par l'utilisateur.
                 * @param {type} scope
                 * @param {type} element
                 * @param {type} attrs
                 */
                function updateSelectView (scope, element, attrs) {
                    // Création de l'url de récupération des vues utilisateur.
                    var url_for_all_views_detail = scope.config.baseurl  + "/configuration" 
                            + "/cfg:config/cfg:view[cfg:info/cfg:category!='Hidden'%20and%20cfg:info/cfg:category!='Configuration'%20and%20cfg:info/cfg:category!='Environment'%20and%20cfg:info/cfg:category!='Monitoring']/@name"
                            + "|/cfg:config/cfg:view[cfg:info/cfg:category!='Hidden'%20and%20cfg:info/cfg:category!='Configuration'%20and%20cfg:info/cfg:category!='Environment'%20and%20cfg:info/cfg:category!='Monitoring']/cfg:info/cfg:category[text()]"
                            + "|/cfg:config/cfg:view[not(cfg:info/cfg:category)]/@name?accept=xml";
                    
                    lavoisierHttpRequestService.getResult({url : url_for_all_views_detail}).then(
                        function (value) {
                            
                            scope.control.viewMustBeInitialized = true;

                            try {
                                // Transformation de la réponse du serveur en json.
                                var jsonEntries = parserService.xml_str2json(value);
                                
                                // Récupération des vues par catégories.
                                var views = {};
                                for (var e = 0 ; e < jsonEntries.entries.entry.length ; e++) {
                                    var categoryName;
                                    try { categoryName = jsonEntries.entries.category[e].__text; } catch (e) { categoryName = noCategory; }
                                    var entryName = jsonEntries.entries.entry[e].__text;
                                    
                                    if (!views[categoryName]) views[categoryName] = [];
                                    if (scope.config.view === entryName) scope.control.viewMustBeInitialized = false;
                                    views[(categoryName ? categoryName : noCategory)].push(entryName);
                                }
                                
                                scope.views = [];
                                // Ajout à scope.views des différentes vues avec : {category , name}
                                for (var index in views) {
                                    for (var o = 0 ; o < views[index].length ; o++) {
                                        scope.views.push({category : index, name : views[index][o]});
                                    }
                                }
                                
                                // Dernière vérification avant validation.
                                if (scope.views.length === 0) throw "Empty views in selectView directive!";
                                                                
                                scope.config.viewOk = true;
                            } catch(e) {
                                failToLoadViews(element, scope, e);
                            }
                        },
                        function () {
                            failToLoadViews(element, scope);
                        }
                    ).then(
                        function () {
                            if (scope.control.viewMustBeInitialized) {
                                scope.config.view = scope.control.controller.defaultViewValue;
                                scope.control.viewMustBeInitialized = false;
                            }
                            
                            templateUrl_ = "views_success.html";
                        },function () {
                            templateUrl_ = "views_failed.html";
                        }
                    );
                }

                return {
                    scope : {
                        control : '='
                    },
                    link : function (scope, element, attrs) {
                        // scope.control = directive attribut control. Ici lavoisierFormEditCtrl.select_view -> ligne : 8.
                        scope.config = scope.control.config;
                        scope.control.controller.majViewContent = function () { updateSelectView(scope, element, attrs); };
                        
                        if (!scope.control.controller.addEvent) {
                            angular.element(document.getElementById("lavoisier_url")).on("focusout", scope.control.controller.majViewContent);
                            scope.control.controller.addEvent = true;
                        }
                        
                        updateSelectView(scope, element, attrs);
                        
                        scope.getContentUrl  = function () {
                            if (templateUrl_) 
                                return LAVOISIER_TEMPLATES_PATH
                                    + "/edit/directives/" + templateUrl_;
                            else return false;
                            
                        };
                    },
                    template : "<div ng-include='getContentUrl()'></div>"
                };
            }
        ]
    );